#include <stdio.h>
#include <stdlib.h>

int main(void)
{
  // parametres d entree
  int nPluie,nCouche;
  float th_cc,*apportEau,val;
  float *dz,*thCI;
  float *date;
  // variable de sortie
  float *th,drainage,stock;
  // variables locales
  FILE *fPluie,*fIn,*fOut;
  int i,j;
  float apportActu;

  // lecture du fichier pluie
  fPluie = fopen("../data/Pluvio_3_1997_06_05.txt","r");
  nPluie = 541;
  apportEau = (float*) calloc(nPluie,sizeof(float));
  date      = (float*) calloc(6,sizeof(float));
  for (i=0;i<nPluie;i++) {
    for (j=0;j<6;j++)
      fscanf(fPluie,"%f",&date[j]);
    fscanf(fPluie,"%f",&apportEau[i]);
    apportEau[i] = 0.001*apportEau[i];
  }
  fclose(fPluie);
  
  // lecture des parametres
  fIn = fopen("../data/in","r");
  fscanf(fIn,"%f\n",&th_cc);
  fscanf(fIn,"%d\n",&nCouche);
  dz   = (float*) calloc(nCouche,sizeof(float));
  thCI = (float*) calloc(nCouche,sizeof(float));
  for (i=0;i<nCouche;i++) {
    fscanf(fIn,"%d %f %f\n",&j,&dz[i],&thCI[i]);
  }
  fclose(fIn);

  // calculs : repartition de l apport sur les couches de sol
  th       = (float*) calloc(nCouche,sizeof(float));
  for (j=0;j<nCouche;j++)
    th[j] = 0;
  drainage = 0;
  printf("pas de temps  |  apport  |  stock   | drainage |\n");
  for (i=0;i<nPluie;i++) {
    apportActu = apportEau[i];
    for (j=0;j<nCouche;j++) {
      if (apportActu>=(th_cc-thCI[j])*dz[j]) {
	th[j]      = th_cc;
	apportActu -= (th_cc-thCI[j])*dz[j];
      }
      else {
	th[j]      = thCI[j] + apportActu/dz[j];
	apportActu = 0;
      }
    }
    drainage += apportActu;
    for (j=0;j<nCouche;j++)
      thCI[j] = th[j];
    stock = 0;
    for (j=0;j<nCouche;j++)
      stock += th[j]*dz[j];
    printf("%14d|%10.4f|%10.4f|%10.4f|\n",i+1,apportEau[i],stock,drainage);
  }
  
  // enregistrement des resultats
  fOut = fopen("../data/out_c","w");
  for (i=0;i<nCouche;i++) {
    fprintf(fOut,"%4d %10.4f %10.4f\n",i+1,dz[i],th[i]);
  }
  fprintf(fOut,"%10.4f\n",drainage);
  
  fclose(fOut);

  return 0;
}
